---
title: ConstrainDOMString
slug: Web/API/ConstrainDOMString
tags:
  - API
  - ConstrainDOMStringParameters
  - Constraints
  - Dictionary
  - Interface
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - Reference
  - Web
  - WebRTC
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The <strong><code>ConstrainDOMString</code></strong> dictionary is used to specify a constraint for a property whose value is a string. It allows you to specify one or more <code>exact</code> string values from which one must be the parameter's value, or a set of <code>ideal</code> values which should be used if possible. You can also specify a single string (or an array of strings) which the user agent will do its best to match once all more stringent constraints have been applied.</p>

<h2 id="Properties">Properties</h2>

<p>The value of a <code>ConstrainDOMString</code> can be any of the following:</p>

<ul>
	<li>A single {{domxref("DOMString")}}</li>
	<li>An array of {{domxref("DOMString")}} objects</li>
	<li>An object with one or both of the following properties:</li>
</ul>

<dl>
	<dt><code>exact</code></dt>
	<dd>Either a single {{domxref("DOMString")}} which must be the value of the property, or an array of <code>DOMString</code> objects one of which must be the property's value. If the property can't be set to one of the listed values, matching will fail.</dd>
	<dt><code>ideal</code></dt>
	<dd>Either a single {{domxref("DOMString")}} or an array of <code>DOMString</code>s specifying ideal values for the property. If possible, one of the listed values will be used, but if it's not possible, the user agent will use the closest possible match.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Media Capture', '#dom-constraindomstring', 'ConstrainDOMString')}}</td>
			<td>{{Spec2('Media Capture')}}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<div class="note">
<p>Technically, <code>ConstrainDOMString</code> is actually based on an intermediary dictionary named <code>ConstrainDOMStringParameters</code>, which adds <code>exact</code> and <code>ideal</code> to {{domxref("DOMString")}}. However, for the sake of documentation clarity, the intermediate type (present only because of quirks in {{Glossary("WebIDL")}} syntax) is ignored here.</p>
</div>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ConstrainDOMString")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
	<li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
	<li>{{domxref("MediaTrackConstraints")}}</li>
	<li>{{domxref("MediaTrackCapabilities")}}</li>
	<li>{{domxref("MediaTrackSupportedConstraints")}}</li>
</ul>
